#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#ifdef MEMDEBUG
#include <mnemosyn.h>
#endif
#define  TRUE (0==0)
#define  FALSE (0!=0)
#include "regexp.h"
#include "language.h"
#ifdef NO_MAIN

extern char **argv;
extern int argc;


extern FILE *yyin;
#else

char **argv = (char **)NULL;
int argc = 0;


FILE *yyin = NULL;
#endif /* MAIN */
#include "taccutil.h"


/* Main cheats - it invokes the parsing routines explicitly,
   in order to reduce the size of the parse tree for a whole
   file.  Also allows recovery of errors at useful boundaries */

 
  
int main_1(YYTYPE *__arg)
{
int __debug = SEEN_main_1 = debug_execute_enter("Executing procedure main_1 -- arg at %p", __arg);

    YYTYPE *subroot;
    void *stacktop;
    int i;

    if (strcmp(argv[argc-1], "-v") == 0) {
      argc -= 1;
      verbose = TRUE;
    }
    if (strcmp(argv[argc-1], "-d") == 0) {
      argc -= 1;
      _debug = TRUE;
    }
    if (strcmp(argv[argc-1], "-vd") == 0) {
      argc -= 1;
      _debug = TRUE;
      verbose = TRUE;
    }


    if (argc == 1) {
       yyin = fopen("source.gt", "r");
    } else if (argc != 2) {
       fprintf(stderr, "syntax: language  source.gt\n");
       /* Let's just resume for now... */
       yyin = fopen(argv[1], "r");
    } else {
       yyin = fopen(argv[1], "r");
    }
    if (yyin == NULL) {
       fprintf(stderr, "language: cannot open input\n");
       exit(EXIT_FAILURE);
    }

    fprintf(stderr, "%s: processing %s\n", argv[0], argv[1] == NULL ? "source.gt" : argv[1]);

    cur_handler = ignore;

    if (verbose) fprintf(stderr, "Starting\n");

    for (;;) {
      stacktop = stackmark();
      if (item_parse(&subroot)) {
          execute_parsetree(subroot);
      } else {
          return(FALSE);
      }
      stackrelease(stacktop);
      if (exit_flag) return(TRUE);
    }
  
if (!_optimise) debug_execute_exit("main_1");
return(TRUE);
}


    
int item_1(YYTYPE *__arg)
{
int __debug = SEEN_item_1 = debug_execute_enter("Executing procedure item_1 -- arg at %p", __arg);
 
if (!_optimise) debug_execute_exit("item_1");
return(TRUE);
}



             
int statement_1(YYTYPE *__arg)
{
int __debug = SEEN_statement_1 = debug_execute_enter("Executing procedure statement_1 -- arg at %p", __arg);

                    int i;
                    exit_flag = TRUE;
                  
if (!_optimise) debug_execute_exit("statement_1");
return(TRUE);
}
            
int statement_2(YYTYPE *__arg)
{
int __debug = SEEN_statement_2 = debug_execute_enter("Executing procedure statement_2 -- arg at %p", __arg);
 
if (!_optimise) debug_execute_exit("statement_2");
return(TRUE);
}
     
int statement_3(YYTYPE *__arg)
{
int __debug = SEEN_statement_3 = debug_execute_enter("Executing procedure statement_3 -- arg at %p", __arg);

		    declare(((USERTYPE *)(__arg->execute.arg[3]->execute.user_value)));
                  
if (!_optimise) debug_execute_exit("statement_3");
return(TRUE);
}
    
int statement_4(YYTYPE *__arg)
{
int __debug = SEEN_statement_4 = debug_execute_enter("Executing procedure statement_4 -- arg at %p", __arg);

		    assign(((USERTYPE *)(__arg->execute.arg[1]->execute.user_value)), ((USERTYPE *)(__arg->execute.arg[3]->execute.user_value)));
		  
if (!_optimise) debug_execute_exit("statement_4");
return(TRUE);
}
           
int statement_5(YYTYPE *__arg)
{
int __debug = SEEN_statement_5 = debug_execute_enter("Executing procedure statement_5 -- arg at %p", __arg);

		    fprintf(stderr, "Syntax: %s\n\n", __arg->execute.arg[1]->execute.text);
                  
if (!_optimise) debug_execute_exit("statement_5");
return(TRUE);
}


  
int multi_1(YYTYPE *__arg)
{
int __debug = SEEN_multi_1 = debug_execute_enter("Executing procedure multi_1 -- arg at %p", __arg);
 
if (!_optimise) debug_execute_exit("multi_1");
return(TRUE);
}

      
int declist_1(YYTYPE *__arg)
{
int __debug = SEEN_declist_1 = debug_execute_enter("Executing procedure declist_1 -- arg at %p", __arg);

		    declare(((USERTYPE *)(__arg->execute.arg[3]->execute.user_value)));
                  
if (!_optimise) debug_execute_exit("declist_1");
return(TRUE);
}
  
int declist_2(YYTYPE *__arg)
{
int __debug = SEEN_declist_2 = debug_execute_enter("Executing procedure declist_2 -- arg at %p", __arg);
 
if (!_optimise) debug_execute_exit("declist_2");
return(TRUE);
}


   
int termin_1(YYTYPE *__arg)
{
int __debug = SEEN_termin_1 = debug_execute_enter("Executing procedure termin_1 -- arg at %p", __arg);
 
if (!_optimise) debug_execute_exit("termin_1");
return(TRUE);
}   
int termin_2(YYTYPE *__arg)
{
int __debug = SEEN_termin_2 = debug_execute_enter("Executing procedure termin_2 -- arg at %p", __arg);
 
if (!_optimise) debug_execute_exit("termin_2");
return(TRUE);
}

  
int sp_1(YYTYPE *__arg)
{
int __debug = SEEN_sp_1 = debug_execute_enter("Executing procedure sp_1 -- arg at %p", __arg);
 
if (!_optimise) debug_execute_exit("sp_1");
return(TRUE);
}

  
int name_1(YYTYPE *__arg)
{
int __debug = SEEN_name_1 = debug_execute_enter("Executing procedure name_1 -- arg at %p", __arg);

		    ((USERTYPE *)(__arg->execute.arg[0]->execute.user_value)) = __arg->execute.arg[1]->execute.text;
		     
if (!_optimise) debug_execute_exit("name_1");
return(TRUE);
}


          
int expr_1(YYTYPE *__arg)
{
int __debug = SEEN_expr_1 = debug_execute_enter("Executing procedure expr_1 -- arg at %p", __arg);
 ((USERTYPE *)(__arg->execute.arg[0]->execute.user_value)) = ((USERTYPE *)(__arg->execute.arg[1]->execute.user_value)); 
if (!_optimise) debug_execute_exit("expr_1");
return(TRUE);
}
    
		     
int expr_2(YYTYPE *__arg)
{
int __debug = SEEN_expr_2 = debug_execute_enter("Executing procedure expr_2 -- arg at %p", __arg);

		       ((USERTYPE *)(__arg->execute.arg[0]->execute.user_value)) = mul(((USERTYPE *)(__arg->execute.arg[1]->execute.user_value)), ((USERTYPE *)(__arg->execute.arg[3]->execute.user_value)));
		     
if (!_optimise) debug_execute_exit("expr_2");
return(TRUE);
}


  
int term_1(YYTYPE *__arg)
{
int __debug = SEEN_term_1 = debug_execute_enter("Executing procedure term_1 -- arg at %p", __arg);
 fprintf(stderr, "term-int: %s\n", ((USERTYPE *)(__arg->execute.arg[1]->execute.user_value))); ((USERTYPE *)(__arg->execute.arg[0]->execute.user_value)) = ((USERTYPE *)(__arg->execute.arg[1]->execute.user_value)); 
if (!_optimise) debug_execute_exit("term_1");
return(TRUE);
}
        
int term_2(YYTYPE *__arg)
{
int __debug = SEEN_term_2 = debug_execute_enter("Executing procedure term_2 -- arg at %p", __arg);
 fprintf(stderr, "term-name: %s\n", ((USERTYPE *)(__arg->execute.arg[1]->execute.user_value))); ((USERTYPE *)(__arg->execute.arg[0]->execute.user_value)) = ((USERTYPE *)(__arg->execute.arg[1]->execute.user_value)); 
if (!_optimise) debug_execute_exit("term_2");
return(TRUE);
}  


  
int number_1(YYTYPE *__arg)
{
int __debug = SEEN_number_1 = debug_execute_enter("Executing procedure number_1 -- arg at %p", __arg);

		    fprintf(stderr, "int: %s\n", __arg->execute.arg[1]->execute.text);
		    ((USERTYPE *)(__arg->execute.arg[0]->execute.user_value)) = __arg->execute.arg[1]->execute.text;
                  
if (!_optimise) debug_execute_exit("number_1");
return(TRUE);
}



int main_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("main_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 0, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("main_parse found option 1 -- \"\" ");
      *__arg = makeparsetree(__temp, main_1, 1, "main", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("main_parse failed");
   return(FALSE);
}

int item_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("item_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& is(sp_parse,&__temp.execute.arg[1]) /* Lazy eval */
&& statement_parse(&__temp.execute.arg[2])
&& termin_parse(&__temp.execute.arg[3])
)  {
      if (!_optimise) debug_exit("item_parse found option 1 -- <?sp> <statement> <termin> ");
      *__arg = makeparsetree(__temp, item_1, 3, "item", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("item_parse failed");
   return(FALSE);
}

int statement_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("statement_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& eof_parse(&__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("statement_parse found option 1 -- ");
      *__arg = makeparsetree(__temp, statement_1, 1, "statement", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("statement_parse - trying option 2"); lev += 1;

if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 1, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("statement_parse found option 2 -- ");
      *__arg = makeparsetree(__temp, statement_2, 1, "statement", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("statement_parse - trying option 3"); lev += 1;

if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 2, &__temp.execute.arg[1])
&& sp_parse(&__temp.execute.arg[2])
&& name_parse(&__temp.execute.arg[3])
&& sp_parse(&__temp.execute.arg[4])
&& declist_parse(&__temp.execute.arg[5])
)  {
      if (!_optimise) debug_exit("statement_parse found option 3 -- ");
      *__arg = makeparsetree(__temp, statement_3, 5, "statement", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("statement_parse - trying option 4"); lev += 1;

if (note_backtrack(&__pos)
&& name_parse(&__temp.execute.arg[1])
&& _regexp_parse(savepat, 3, &__temp.execute.arg[2])
&& expr_parse(&__temp.execute.arg[3])
)  {
      if (!_optimise) debug_exit("statement_parse found option 4 -- ");
      *__arg = makeparsetree(__temp, statement_4, 3, "statement", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("statement_parse - trying option 5"); lev += 1;

if (note_backtrack(&__pos)
&& not(multi_parse,&__temp.execute.arg[1]) /* Lazy eval */
&& _regexp_parse(savepat, 4, &__temp.execute.arg[2])
&& _regexp_parse(savepat, 5, &__temp.execute.arg[3])
)  {
      if (!_optimise) debug_exit("statement_parse found option 5 -- <!multi> \".*\" \"$\" ");
      *__arg = makeparsetree(__temp, statement_5, 3, "statement", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("statement_parse failed");
   return(FALSE);
}

int multi_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("multi_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 6, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("multi_parse found option 1 -- \".*;\" ");
      *__arg = makeparsetree(__temp, multi_1, 1, "multi", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("multi_parse failed");
   return(FALSE);
}

int declist_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("declist_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 7, &__temp.execute.arg[1])
&& sp_parse(&__temp.execute.arg[2])
&& name_parse(&__temp.execute.arg[3])
&& sp_parse(&__temp.execute.arg[4])
&& declist_parse(&__temp.execute.arg[5])
)  {
      if (!_optimise) debug_exit("declist_parse found option 1 -- ");
      *__arg = makeparsetree(__temp, declist_1, 5, "declist", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("declist_parse - trying option 2"); lev += 1;

if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 8, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("declist_parse found option 2 -- \"\" ");
      *__arg = makeparsetree(__temp, declist_2, 1, "declist", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("declist_parse failed");
   return(FALSE);
}

int termin_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("termin_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 9, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("termin_parse found option 1 -- ");
      *__arg = makeparsetree(__temp, termin_1, 1, "termin", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("termin_parse - trying option 2"); lev += 1;

if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 10, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("termin_parse found option 2 -- \"$\" ");
      *__arg = makeparsetree(__temp, termin_2, 1, "termin", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("termin_parse failed");
   return(FALSE);
}

int sp_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("sp_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 11, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("sp_parse found option 1 -- \"[ \\t]*\" ");
      *__arg = makeparsetree(__temp, sp_1, 1, "sp", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("sp_parse failed");
   return(FALSE);
}

int name_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("name_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 12, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("name_parse found option 1 -- \"[a-z][a-z0-9]*\" ");
      *__arg = makeparsetree(__temp, name_1, 1, "name", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("name_parse failed");
   return(FALSE);
}

int expr_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("expr_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& term_parse(&__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("expr_parse found option 1 -- ");
      *__arg = makeparsetree(__temp, expr_1, 1, "expr", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("expr_parse - trying option 2"); lev += 1;

if (note_backtrack(&__pos)
&& term_parse(&__temp.execute.arg[1])
&& _regexp_parse(savepat, 13, &__temp.execute.arg[2])
&& expr_parse(&__temp.execute.arg[3])
&& sp_parse(&__temp.execute.arg[4])
)  {
      if (!_optimise) debug_exit("expr_parse found option 2 -- <term> \"[ \\t]*([ \\t]*\" <expr> <sp> ");
      *__arg = makeparsetree(__temp, expr_2, 4, "expr", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("expr_parse failed");
   return(FALSE);
}

int term_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("term_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& number_parse(&__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("term_parse found option 1 -- ");
      *__arg = makeparsetree(__temp, term_1, 1, "term", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("term_parse - trying option 2"); lev += 1;

if (note_backtrack(&__pos)
&& name_parse(&__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("term_parse found option 2 -- <name> ");
      *__arg = makeparsetree(__temp, term_2, 1, "term", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("term_parse failed");
   return(FALSE);
}

int number_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("number_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 14, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("number_parse found option 1 -- \"[0-9][0-9]*\" ");
      *__arg = makeparsetree(__temp, number_1, 1, "number", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("number_parse failed");
   return(FALSE);
}


static int cover_test(void)
{
if ((cover_testing) && (!SEEN_main_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule main not tested\n");
if ((cover_testing) && (!SEEN_item_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule item not tested\n");
if ((cover_testing) && (!SEEN_statement_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule statement not tested\n");
if ((cover_testing) && (!SEEN_statement_2)) LogWarning(ProgName, "language.e", 0, "Alternative 2 of rule statement not tested\n");
if ((cover_testing) && (!SEEN_statement_3)) LogWarning(ProgName, "language.e", 0, "Alternative 3 of rule statement not tested\n");
if ((cover_testing) && (!SEEN_statement_4)) LogWarning(ProgName, "language.e", 0, "Alternative 4 of rule statement not tested\n");
if ((cover_testing) && (!SEEN_statement_5)) LogWarning(ProgName, "language.e", 0, "Alternative 5 of rule statement not tested\n");
if ((cover_testing) && (!SEEN_multi_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule multi not tested\n");
if ((cover_testing) && (!SEEN_declist_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule declist not tested\n");
if ((cover_testing) && (!SEEN_declist_2)) LogWarning(ProgName, "language.e", 0, "Alternative 2 of rule declist not tested\n");
if ((cover_testing) && (!SEEN_termin_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule termin not tested\n");
if ((cover_testing) && (!SEEN_termin_2)) LogWarning(ProgName, "language.e", 0, "Alternative 2 of rule termin not tested\n");
if ((cover_testing) && (!SEEN_sp_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule sp not tested\n");
if ((cover_testing) && (!SEEN_name_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule name not tested\n");
if ((cover_testing) && (!SEEN_expr_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule expr not tested\n");
if ((cover_testing) && (!SEEN_expr_2)) LogWarning(ProgName, "language.e", 0, "Alternative 2 of rule expr not tested\n");
if ((cover_testing) && (!SEEN_term_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule term not tested\n");
if ((cover_testing) && (!SEEN_term_2)) LogWarning(ProgName, "language.e", 0, "Alternative 2 of rule term not tested\n");
if ((cover_testing) && (!SEEN_number_1)) LogWarning(ProgName, "language.e", 0, "Alternative 1 of rule number not tested\n");
}
#ifndef NO_MAIN  /* Get this by default */

int main(int local_argc, char **local_argv)
{
YYTYPE *root; /* Or could be a single YYTYPE, plus an explicit makeparsetree() */
int i;
   argv = local_argv; argc = local_argc;
   /* Should open file yyin here; do it in first entry routine *only* if
   it recognises the null phrase "" */
   if (main_parse(&root)) {
      dump_parsetree(root);
      execute_parsetree(root);
   } else {
      fprintf(stderr, "Parse fail\n");
      for (i = 0; i < 15; i++) if (savepat[i].r != NULL) free(savepat[i].r);
      exit(EXIT_FAILURE);
   }
   /*free_parsetree(root);*/ /*free(root);*/
   cover_test();
   exit(EXIT_SUCCESS);
}
#endif /* not NO_MAIN */

static void _regexp_freeall(void) {
int i;
   for (i = 0; i < 15; i++) if (savepat[i].r != NULL) free(savepat[i].r);
}
