#ifndef _LOG_H
#define _LOG_H

/* Headers for log.c */
extern void ctrlclean(char *in);
extern void LogFatal(
  char *ProgName, char *source_file, long source_off, const char *fmt, ...);
extern void LogDataError(
  char *ProgName, char *source_file, long source_off, const char *fmt, ...);
extern void LogDataWarning(
  char *ProgName, char *source_file, long source_off, const char *fmt, ...);
extern void LogError(
  char *ProgName, char *source_file, long source_off, const char *fmt, ...);
extern void LogWarning(
  char *ProgName, char *source_file, long source_off, const char *fmt, ...);
/* End of headers for log.c */

#endif /* _LOG_H */
